#include"FC2722.h"
#include"tim.h"
#include"key.h"
#include"global.h"
#include"eeprom.h"
#include"uart.h"

#include"tim.h"
#include"key.h"
#include"global.h"
#include"eeprom.h"
#include"uart.h"


#define  DEBUG  0

struct LED_STRUCT ledStruct={1,1,1};
void scan_led(void);
void led_ctr(void);
void key_service(void);
void system_init(void);


/******************************************************************************************************
*      ƣvoid uart_send_sync_signal(void)
*      ܣ
*  ڲ
*  ڲ
*      
*      ڣ20201120
*      ߣм
******************************************************************************************************/
void uart_send_sync_signal(void)
{
  static uint8_t u8i=0;
  u8i++;
  if(u8i>1)
  {
    u8i=0;
    struct_uart.u8UartTxdBuf[0]=ledStruct.u8ledFlag; 
    struct_uart.u8txdStep=0;
    struct_uart.u8txdCount=1;        
    struct_uart.bitUartTxdEnable=1;//ʼ   
  }
}
/******************************************************************************************************
*      ƣvoid read_dat_from_e2porom(void)
*      ܣ
*  ڲ
*  ڲ
*      
*      ڣ20201120
*      ߣм
******************************************************************************************************/
#define ERR  1
void read_dat_from_e2porom(void)
{
  uint8_t tmp=0,bitRead=0;
 //ϵȶȡE2PROMеֵ
  tmp=eepromRead(CHECK_SUM_ADDR);
  if(tmp==0xAF)
  {  
    tmp=eepromRead(LED_STATUS_ADDR);
    if(tmp<=RIGHT_2)
    {
      ledStruct.u8ledStatus=tmp;      
    }
    else
    {
      bitRead=ERR;  
    }  
    tmp=eepromRead(LED_STATUS_BAK_ADDR);
    if(tmp<=RIGHT_2)
    {
      ledStruct.u8ledStatusBak=tmp;     
    }
    else
    {
      bitRead=ERR;
    }
    tmp=eepromRead(LED_FLASH_ADDR);
    if(tmp<=FLASH_16)
    {  
      ledStruct.u8ledFlashStatus=tmp;
    }
    else
    {
      bitRead=ERR;
    }  
  }
  else
  {
    bitRead=ERR;  
  }  
  if(bitRead==ERR)
  {
    ledStruct.u8ledStatus=0x01;
    ledStruct.u8ledStatusBak=0x01;
    ledStruct.u8ledFlashStatus=0x01;
    eepromWrite(LED_STATUS_ADDR,0x01);      
    eepromWrite(LED_STATUS_BAK_ADDR,0x01);      
    eepromWrite(LED_FLASH_ADDR,0x01);      
    eepromWrite(CHECK_SUM_ADDR,0xAF);  
  }    
}   
/******************************************************************************************************
*      ƣvoid scan_led(void)
*      ܣ
*  ڲ
*  ڲ
*      
*      ڣ20201119
*      ߣм
******************************************************************************************************/
void scan_led(void)
{
  static uint8_t bitToggle=0;
  if(bitToggle)
  {
    COM2_DIS;
    if(ledStruct.u8ledFlag&0x01)
    LED1_EN;  
    else
    LED1_DIS;  
    if(ledStruct.u8ledFlag&0x02)
    LED2_EN;  
    else
    LED2_DIS;   
    if(ledStruct.u8ledFlag&0x04)
    LED3_EN;  
    else
    LED3_DIS;   
    if(ledStruct.u8ledFlag&0x08)
    LED4_EN;  
    else
    LED4_DIS;       
    COM1_EN;
    bitToggle=0;        
  }  
  else
  {
    COM1_DIS;
    if(ledStruct.u8ledFlag&0x10)
    LED5_EN;  
    else
    LED5_DIS;  
    if(ledStruct.u8ledFlag&0x20)
    LED6_EN;  
    else
    LED6_DIS;   
    if(ledStruct.u8ledFlag&0x40)
    LED7_EN;  
    else
    LED7_DIS;   
    if(ledStruct.u8ledFlag&0x80)
    LED8_EN;  
    else
    LED8_DIS; 
    COM2_EN;    
    bitToggle=1;
  }      
}   
/******************************************************************************************************
*      ƣvoid led_ctr(void)
*      ܣLED,
*  ڲ
*  ڲ
*      
*      ڣ20201118
*      ߣм
******************************************************************************************************/
__ROM uint8_t LeftPointTable[9]={0x00,0x80,0x40,0x20,0x10,0x08,0x04,0x02,0x01};//Ƶˮ
__ROM uint8_t LeftLineTable[9]={0x00,0x80,0xC0,0xE0,0xF0,0xF8,0xFC,0xFE,0xFF};//

__ROM uint8_t RightPonintTable[9]={0x00,0x01,0x02,0x04,0x08,0x10,0x20,0x40,0x80};//Ƶˮ
__ROM uint8_t RightLineTable[9]={0x00,0x01,0x03,0x07,0x0F,0x1F,0x3F,0x7F,0xFF};//

__ROM uint8_t MiddlePointTable[5]={0x00,0x18,0x24,0x42,0x81};//м˫Ƶˮ 
__ROM uint8_t MiddleLineTable[5] ={0x00,0x18,0x3C,0x7E,0xFF}; //м
__ROM uint8_t MiddleOppositeLineTable[5]={0x00,0x81,0xC3,0xE7,0xFF};//м
__ROM uint8_t flash2Table[2]={0xC3,0x3C};
__ROM uint8_t flash3Table[2]={0x00,0xFF};
__ROM uint8_t flash4Table[2]={0xF0,0x0F};
__ROM uint8_t flash5Table[2]={0xAA,0x55};
__ROM uint8_t flash8Table[5]={0x00,0x03,0x0C,0x30,0xC0};
__ROM uint8_t flash9Table[5]={0x00,0xC0,0x30,0x0C,0x03};
__ROM uint8_t flash10Table[5]={0x00,0xC0,0xF0,0xFC,0xFF};
__ROM uint8_t flash11Table[5]={0x00,0x03,0x0F,0x3F,0xFF};

__ROM uint8_t flash14Table[32]=
{
  0x0F,0x00,0x0F,0x00,0x0F,0x00,0x0F,0x00,0x0F,0x00,0x0F,0x00,0x0F,0x00,0x0F,0x00,  
  0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,
};

__ROM uint8_t flash15Table[48]=
{
  0x0F,0x00,0x0F,0x00,0x0F,0x00,0x0F,0x00,0x0F,0x00,0x0F,0x00,0x0F,0x00,0x0F,0x00,  
  0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,0xF0,0x00,
  0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,0xFF,0x00,  
};

void led_play_dat(__ROM uint8_t *u8ptr,uint8_t u8count)
{
  uint8_t tmp=12;
  if(u8count>31)
  tmp=6; 
  if(ledStruct.u8ledStatus==FLASH_4)
  {
    tmp=18;
  } 
  
  ledStruct.u8i++;
  if(ledStruct.u8i>tmp)
  {  
    ledStruct.u8i=0;
    
    ledStruct.u8ledFlag=u8ptr[ledStruct.u8x];
    ledStruct.u8x++;
    if(ledStruct.u8x>=u8count)
    ledStruct.u8x=0;
    
    //һͬʱ
    struct_uart.bitStartBitEnable=1;
  }  
}  


void led_ctr(void)
{
  switch(ledStruct.u8ledStatus)
  {
    case OFF:
      ledStruct.u8ledFlag=0x00;
    break;  
    case FLASH_1:
      ledStruct.u8ledFlag=0xFF;
    break;
    case FLASH_2:
      led_play_dat(flash2Table,2);  
    break;
    case FLASH_3:
      led_play_dat(flash3Table,2);          
    break;
    case FLASH_4:
      led_play_dat(flash4Table,2);       
    break;
    case FLASH_5:
      led_play_dat(flash5Table,2);     
    break;
    case FLASH_6:
    led_play_dat(MiddleLineTable,5);       
    break;
    case FLASH_7:
    led_play_dat(MiddleOppositeLineTable,5);       
    break;
    case FLASH_8:
    led_play_dat(flash8Table,5);         
    break;
    case FLASH_9:
    led_play_dat(flash9Table,5);         
    break;
    case FLASH_10:
    led_play_dat(flash10Table,5);  
    break;    
    case FLASH_11:
    led_play_dat(flash11Table,5);  
    break;    
    case FLASH_12:
    led_play_dat(RightLineTable,9);       
    break;  
    case FLASH_13:
    led_play_dat(LeftLineTable,9);       
    break;  
    case FLASH_14:
    led_play_dat(flash14Table,32);        
    break; 
    case FLASH_15:
    led_play_dat(flash15Table,48);   
    break; 
    case FLASH_16:
    ledStruct.u8ledFlag=0x00;  
    break;  
    
    case LEFT_1:
    led_play_dat(LeftLineTable,9);        
    break;
    
    case LEFT_2:
    led_play_dat(LeftPointTable,9);          
    break;
    
    case MIDDLE_1:
    led_play_dat(MiddleLineTable,5); 
    break; 
    
    case MIDDLE_2:
    led_play_dat(MiddlePointTable,5); 
    break;
    
    case RIGHT_1:
    led_play_dat(RightLineTable,9);      
    break;   
    
    case RIGHT_2:
    led_play_dat(RightPonintTable,9);
    break;         
  }  
}
/******************************************************************************************************
*      ƣvoid key_service(void)
*      ܣ
*  ڲstructKey.u8KeyValue         structKey.bitShortClick
*  ڲ
*  ˵    
*      
*      ڣ202064
*      ߣм
******************************************************************************************************/
void key_service(void)
{
  if(structKey.bitShortClick)
  {
    structKey.bitShortClick=0;
    ledStruct.u8ledFlag=0x00;
	COM1_DIS;
	COM2_DIS;
    ledStruct.u8x=0;  
    ledStruct.u8i=0;   
    if(ledStruct.u8ledStatus==OFF)
    {
      //ػ״̬£ǿЧ
      if(structKey.u8KeyValue!=0x01)
      return;  
    }  
    
	switch(structKey.u8KeyValue)
	{
      case 0x01://ONOFF 
      if(ledStruct.u8ledStatus==OFF)
      {  
        ledStruct.u8ledStatus=ledStruct.u8ledStatusBak;   //         
      }  
      else
      {
        ledStruct.u8ledStatus=OFF;                        //ڿ״̬͹ػ
      }     
      eepromWrite(LED_STATUS_ADDR,ledStruct.u8ledStatus);      
      eepromWrite(LED_STATUS_BAK_ADDR,ledStruct.u8ledStatusBak);      
      eepromWrite(LED_FLASH_ADDR,ledStruct.u8ledFlashStatus);	   
      break;
 
      case 0x02://FLASH 
      if(ledStruct.u8ledStatus>FLASH_16)
      {
        ledStruct.u8ledStatus=ledStruct.u8ledStatusBak=ledStruct.u8ledFlashStatus;
      }
      else
      {
        ledStruct.u8ledFlashStatus++;
        if(ledStruct.u8ledFlashStatus>FLASH_16)
        {
          ledStruct.u8ledFlashStatus=FLASH_1;  
        } 
        ledStruct.u8ledStatus=ledStruct.u8ledStatusBak=ledStruct.u8ledFlashStatus;        
      } 
      eepromWrite(LED_STATUS_ADDR,ledStruct.u8ledStatus);      
      eepromWrite(LED_STATUS_BAK_ADDR,ledStruct.u8ledStatusBak);      
      eepromWrite(LED_FLASH_ADDR,ledStruct.u8ledFlashStatus);
      break;
      
      case 0x04://LEFT 
      if(ledStruct.u8ledStatus==LEFT_1)
      {
        ledStruct.u8ledStatus=ledStruct.u8ledStatusBak=LEFT_2;
      }
      else
      {
        ledStruct.u8ledStatus=ledStruct.u8ledStatusBak=LEFT_1;        
      } 
      eepromWrite(LED_STATUS_ADDR,ledStruct.u8ledStatus);      
      eepromWrite(LED_STATUS_BAK_ADDR,ledStruct.u8ledStatusBak);        
      break; 

      case 0x08://MIDDLE
      if(ledStruct.u8ledStatus==MIDDLE_1)
      {
        ledStruct.u8ledStatus=ledStruct.u8ledStatusBak=MIDDLE_2;
      }
      else
      {
        ledStruct.u8ledStatus=ledStruct.u8ledStatusBak=MIDDLE_1;        
      } 
      eepromWrite(LED_STATUS_ADDR,ledStruct.u8ledStatus);      
      eepromWrite(LED_STATUS_BAK_ADDR,ledStruct.u8ledStatusBak);        
      break; 

      case 0x10://RIGHT 
    
      if(ledStruct.u8ledStatus==RIGHT_1)
      {
        ledStruct.u8ledStatus=ledStruct.u8ledStatusBak=RIGHT_2;
      }
      else
      {
        ledStruct.u8ledStatus=ledStruct.u8ledStatusBak=RIGHT_1;        
      }  
      eepromWrite(LED_STATUS_ADDR,ledStruct.u8ledStatus);      
      eepromWrite(LED_STATUS_BAK_ADDR,ledStruct.u8ledStatusBak);        
      break;            
	   }
 
  } 
}   
/******************************************************************************************************
*      ƣvoid system_init(void)
*      ܣϵͳʼ
*  ڲ
*  ڲ
*      ڣ2017.11.18
*      ߣм
******************************************************************************************************/
void system_init(void)
{
  P1=0x00;		//0000 0000
  P1M=0xFF;	    //1111 1111 ;0=in / 1=out
  P1UR=0x00;	//0000 0000 ;UP_pull;0=dis / 1=en
  P1W=0x00;		//0000 0000	;wakeup ;0=dis / 1=en

  P2=0x00;		//0000 0000
  P2M=0xFF;	    //1111 1011 ;0=in / 1=out
  P2UR=0x00;	//0000 0100 ;UP_pull;0=dis / 1=en
  P2W=0x00;		//0000 0000	;wakeup ;0=dis / 1=en

  P3=0x00;		//0000 0000
  P3M=0xF8;	    //1111 1111 ;0=in / 1=out
  P3UR=0x07;	//0000 0000 ;UP_pull;0=dis / 1=en
  P3W=0x00;		//0000 0000	;wakeup ;0=dis / 1=en

  FGIE=0u;
  INTEN=0x00u;	//0000 0000 /7-ADCIE  ;6-I2CIE  ;5-RPIE  ;4-TM2IE  ;3-TM1IE ;2-TM0IE ;1-INT1IE  ;0-INT0IE ;
  INTRQ=0x00u;	//0000 0000 /7-ADCIF  ;6-I2CIF  ;5-RPIF  ;4-TM2IF  ;3-TM1IF ;2-TM0IF ;1-INT1IF  ;0-INT0IF ;
  INTEN1=0x00u;	//0000 0000 /7-       ;6-       ;5-      ;4-OPAIE  ;3-T0IE  ;2-SPIIE ;1-TKTMRIE ;0-       ;
  INTRQ1=0x00u;	//0000 0000 /7-       ;6-       ;5-      ;4-OPAIF  ;3-T0IF  ;2-SPIIF ;1-TKTMRIF ;0-       ;

  PEDGE=0x00u;	//0000 0000 /7-INT1S2 ;6-INT1S1 ;5-INT1S0;4-INT1G1 ;3-INT1G0;2-INT0G1;1-INT0G0  ;0-INT0S  ;
  FGIE=0u;

  OPTION=0x10u;	//0001 0000 /7-RCADJEN;6-LIRC_EN;5-LDOEN ;4-LVDTEN ;3-RTCCON;2-WDTP2 ;1-WDTP1   ;0-WDTP0  ;

  T0M=0x00u;		//0000 ---- /7-T0TR   ;6-T0PS2  ;5-T0PS1 ;4-T0PS0  ;3-      ;2-      ;1-        ;0-       ;
  T0C=0x00u;		//0000 0000
	//******************************************************************
	//TM0(16bit)
  TM0M=0x00u;		//0000 0000 /7-TM0TR  ;6-TM0PS2 ;5-TM0PS1;4-TM0PS0 ;3-TM0CKS1;2-TM0CKS0;1-ALOAD ;0-PWM00E ;
  TM0CL=0;	//0000 0000
  TM0CH=0x00u;	//0000 0000
  TM0D0L=0x00u;	//0000 0000
  TM0D0H=0x00u;	//0000 0000
  TM0D1L=0x00u;	//0000 0000
  TM0D1H=0x00u;	//0000 0000
  PWM0E=0x00u;	//0000 0000 /7-PWM03OE;6-PWM02OE;5-PWM01OE;4-PWM00OE;3-PWM0M ;2-PWM03E ;1-PWM02E;0-PWM01E ;
	//******************************************************************
	//TM1(8bit)
  TM1M=0xf2u;		//1111 0011	/7-TM1TR  ;6-TM1PS2 ;5-TM1PS1;4-TM1PS0 ;3-TM1CKS1;2-TM1CKS0;1-ALOAD ;0-PWM10E ;
  TM1C=155;	  	//0000 0000	/PWM10  ռձȼĴ
  TM1D0=0x00u;	//0000 0000
  TM1D1=0x00u;	//0000 0000
  TM1D2=0x00u;	//0000 0000
  TM1D3=0x00u;	//0000 0000
  PWM1E=0x00u;	//0000 0000	/7-PWM13OE;6-PWM12OE;5-PWM11OE;4-PWM10OE;3-PWM1M ;2-PWM13E ;1-PWM12E;0-PWM11E ;
	//******************************************************************
	//TM2(8bit)
  TM2M=0x00;		//1111 0011	/7-TM2TR  ;6-TM2PS2 ;5-TM2PS1;4-TM2PS0 ;3-TM2CKS1;2-TM2CKS0;1-ALOAD ;0-PWM20E ;
  TM2C=0;	  	//0010 0000	/PWM20  ռձȼĴ
  TM2D0=0x00u;	//0000 0000
  TM2D1=0x00u;	//0000 0000
  TM2D2=0x00u;	//0000 0000
  TM2D3=0x00u;	//0000 0000
  PWM2E=0x00u;	//0001 0000	/7-PWM23OE;6-PWM22OE;5-PWM21OE;4-PWM20OE;3-PWM2M ;2-PWM23E ;1-PWM22E;0-PWM21E ;
} 
